# -*- coding: utf-8 -*-
from openerp import models, fields
import inspect

DEFAULT_BLACKLIST = ['create_uid', '__last_update', 'sequence', 'write_uid', 'write_date']

'''
'''
def serialize(obj, blacklist = []):
    attributes = [a for a in inspect.getmembers(obj, lambda a:not(inspect.isroutine(a))) if a[0] == '_fields']
    data = {}

    for field in dict(attributes[0][1]):
        if field in blacklist:
            continue

        obj_value = getattr(obj, field)

        if 'class' in str(type(obj_value)):
            data[field] = [o.id for o in obj_value] if obj_value else []
            continue

        data[field] = getattr(obj, field)

    return data

'''
    Users class with token field for manage authentication
'''
class res_users(models.Model):
    _inherit = 'res.users'

    jwt_token = fields.Char(string = 'JWT Authentication Token');

    def dump(self, blacklist = []):
        return serialize(self, blacklist + DEFAULT_BLACKLIST)

'''
'''
class res_partner(models.Model):
    _inherit = 'res.partner'

    def dump(self, blacklist = []):
        return serialize(self, blacklist + DEFAULT_BLACKLIST)

'''
'''
class crm_lead(models.Model):
    _inherit = 'crm.lead'

    def dump(self, blacklist = []):
        return serialize(self, blacklist + DEFAULT_BLACKLIST)
'''
'''
class product_template(models.Model):
    _inherit = 'product.template'

    def dump(self, blacklist = []):
        return serialize(self, blacklist + DEFAULT_BLACKLIST)

'''
'''
class product_attribute_line(models.Model):
    _inherit = 'product.attribute.line'

    def dump(self, blacklist = []):
        return serialize(self, blacklist + DEFAULT_BLACKLIST)

'''
'''
class product_attribute(models.Model):
    _inherit = 'product.attribute'

    def dump(self, blacklist = []):
        return serialize(self, blacklist + DEFAULT_BLACKLIST)

'''
'''
class product_attribute_price(models.Model):
    _inherit = 'product.attribute.price'

    def dump(self, blacklist = []):
        return serialize(self, blacklist + DEFAULT_BLACKLIST)

'''
'''
class product_attribute_value(models.Model):
    _inherit = 'product.attribute.value'

    def dump(self, blacklist = []):
        return serialize(self, blacklist + DEFAULT_BLACKLIST)

'''
'''
class product_product(models.Model):
    _inherit = 'product.product'

    def dump(self, blacklist = []):
        return serialize(self, blacklist, DEFAULT_BLACKLIST)
